'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.identifier = identifier;
exports.connect = connect;
exports.wrapQueryFn = wrapQueryFn;

var _effects = require('redux-saga/effects');

var _reactRedux = require('react-redux');

var _invariants = require('../invariants');

var _invariants2 = _interopRequireDefault(_invariants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** Get entity identifier: either `id` as-is or the result of calling `id(props)`. */
function identifier(displayName, id, props) {
  var realId = typeof id === 'function' ? id(props) : id;
  _invariants2.default.isIdentifierValue(realId, displayName);
  return realId;
}

/** Wrap component in react-redux connect. */
function connect(cls) {
  return (0, _reactRedux.connect)(function (_ref) {
    var wordpress = _ref.wordpress;

    _invariants2.default.hasWordpressObject(wordpress);
    return { wordpress: wordpress };
  })(cls);
}

/** Wrap `queryFn` in a function that takes the node-wpapi instance. */
function wrapQueryFn(queryFn, props, state) {
  return (/*#__PURE__*/regeneratorRuntime.mark(function _callee(wpapi) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _effects.call)(queryFn, wpapi, props, state);

            case 2:
              return _context.abrupt('return', _context.sent);

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    })
  );
}