'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ContentTypesPlural;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// WP-API namespace (`wp-json/${namespace}`)
var WpApiNamespace = exports.WpApiNamespace = 'wp/v2';

var PreloadQueryId = exports.PreloadQueryId = 'PRELOAD_QUERY_ID';

var ActionTypes = exports.ActionTypes = {
  // Initiate a request to the WP API
  RequestCreatePost: 'kasia/REQUEST_CREATE_POST',
  RequestCreateQuery: 'kasia/REQUEST_CREATE_QUERY',
  // Place record of a request in the store
  RequestAck: 'kasia/REQUEST_ACK',
  // Place the result of a request on the store
  RequestComplete: 'kasia/REQUEST_COMPLETE',
  // Record the failure of a request on the store
  RequestFail: 'kasia/REQUEST_FAILED',
  // Reset the queryId counter to zero
  RewindQueryCounter: 'kasia/REWIND_QUERY_COUNTER',
  // Increment the next query ID
  IncrementNextQueryId: 'kasia/INCREMENT_NEXT_QUERY_ID'

  // The built-in content types available in WordPress.
};var ContentTypes = exports.ContentTypes = {
  Category: 'category',
  Comment: 'comment',
  Media: 'media',
  Page: 'page',
  Post: 'post',
  PostStatus: 'status',
  PostType: 'type',
  PostRevision: 'revision',
  Tag: 'tag',
  Taxonomy: 'taxonomy',
  User: 'user'

  // Plural names of the built-in content types. These are used in determining the
  // wpapi method to call when fetching a content type's respective data.
};var ContentTypesPlural = exports.ContentTypesPlural = (_ContentTypesPlural = {}, _defineProperty(_ContentTypesPlural, ContentTypes.Category, 'categories'), _defineProperty(_ContentTypesPlural, ContentTypes.Comment, 'comments'), _defineProperty(_ContentTypesPlural, ContentTypes.Media, 'media'), _defineProperty(_ContentTypesPlural, ContentTypes.Page, 'pages'), _defineProperty(_ContentTypesPlural, ContentTypes.Post, 'posts'), _defineProperty(_ContentTypesPlural, ContentTypes.PostStatus, 'statuses'), _defineProperty(_ContentTypesPlural, ContentTypes.PostType, 'types'), _defineProperty(_ContentTypesPlural, ContentTypes.PostRevision, 'revisions'), _defineProperty(_ContentTypesPlural, ContentTypes.Tag, 'tags'), _defineProperty(_ContentTypesPlural, ContentTypes.Taxonomy, 'taxonomies'), _defineProperty(_ContentTypesPlural, ContentTypes.User, 'users'), _ContentTypesPlural);

// These content types do not have `id` properties.
var ContentTypesWithoutId = exports.ContentTypesWithoutId = [ContentTypes.Category, ContentTypes.PostType, ContentTypes.PostStatus, ContentTypes.Taxonomy];