'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.preload = preload;
exports.preloadQuery = preloadQuery;

var _effects = require('redux-saga/effects');

var _actions = require('../redux/actions');

var _constants = require('../constants');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/** Make a preloader saga for all Kasia components within the `components` array. */
function preload(components) {
  var renderProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var state = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!Array.isArray(components)) {
    throw new Error('Expecting components to be array, got "' + (typeof components === 'undefined' ? 'undefined' : _typeof(components)) + '".');
  } else if ((typeof renderProps === 'undefined' ? 'undefined' : _typeof(renderProps)) !== 'object') {
    throw new Error('Expecting renderProps to be an object, got "' + (typeof renderProps === 'undefined' ? 'undefined' : _typeof(renderProps)) + '".');
  } else if ((typeof state === 'undefined' ? 'undefined' : _typeof(state)) !== 'object') {
    throw new Error('Expecting state to be an object, got "' + (typeof state === 'undefined' ? 'undefined' : _typeof(state)) + '".');
  }

  return (/*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var tasks;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return components.map(function (c) {
                return c && typeof c.preload === 'function' ? c : false;
              }).filter(Boolean).map(function (component) {
                return component.preload(renderProps, state);
              }).map(function (_ref) {
                var _ref2 = _slicedToArray(_ref, 2),
                    fn = _ref2[0],
                    action = _ref2[1];

                return (0, _effects.fork)(fn, action);
              });

            case 2:
              tasks = _context.sent;

              if (!tasks.length) {
                _context.next = 6;
                break;
              }

              _context.next = 6;
              return _effects.join.apply(undefined, _toConsumableArray(tasks));

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    })
  );
}

/** Make a preloader saga that fetches data for an arbitrary WP API query. */
function preloadQuery(queryFn) {
  var renderProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var state = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (typeof queryFn !== 'function') {
    throw new Error('Expecting queryFn to be a function, got "' + queryFn + '".');
  } else if ((typeof renderProps === 'undefined' ? 'undefined' : _typeof(renderProps)) !== 'object') {
    throw new Error('Expecting renderProps to be an object, got "' + (typeof renderProps === 'undefined' ? 'undefined' : _typeof(renderProps)) + '".');
  } else if ((typeof state === 'undefined' ? 'undefined' : _typeof(state)) !== 'object') {
    throw new Error('Expecting state to be an object, got "' + (typeof state === 'undefined' ? 'undefined' : _typeof(state)) + '".');
  }

  return (/*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var data;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return queryFn(renderProps, state);

            case 2:
              data = _context2.sent;
              _context2.next = 5;
              return (0, _effects.put)((0, _actions.completeRequest)(_constants.PreloadQueryId, data));

            case 5:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    })
  );
}